Subject: Re: bug#75018: 30.0.93; Dired icon missing in tool-bar
From: Eli Zaretskii <[email-masked]>
To: john muhl <[email-masked]>
Cc: [email-masked]
Date: Sat, 28 Dec 2024 13:56:08 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

> From: john muhl <[email-masked]>
> Cc: [email-masked]
> Date: Mon, 23 Dec 2024 11:21:06 -0600
> 
> Eli Zaretskii <[email-masked]> writes:
> 
> >> From: john muhl <[email-masked]>
> >> Cc: [email-masked]
> >> Date: Sun, 22 Dec 2024 17:57:04 -0600
> >> 
> >> The following gets all the icons working:
> >> 
> >>   dnf install gdk-pixbuf2-modules-extra
> >> 
> >> Maybe something to mention PROBLEMS? Feel free to close unless you
> >> think there anything else to investigate.
> >
> > I'm okay with having a PROBLEMS entry about this, but I'd be much
> > happier if I understood some more about the problem.  How does
> > installing those icons solve the problem?  Is the problem caused by
> > absence of some icons, and the strange display is just an indication
> > that the file is missing?
> 
> The gdk-pixbuf2-modules-extra package doesn’t install any
> icons. It installs support for loading additional image formats:
> 
>   This package contains modules for loading ANI, BMP, ICNS, ICO,
>   PNM, QTIF, TGA, XBM, and XPM images.
> 
> What appears to have happened is that the loaders for these
> formats were removed from the main GDK packages in Fedora 41 thus
> any attempt to load an XPM fails (in Emacs and all other
> programs). Why the developers decided to use those strange icons
> in case of failure is unclear and probably beyond my investigative
> abilities.
> 
> Ultimately Fedora needs to fix their Emacs package so that
> gdk-pixbuf2-modules-extra is listed among the dependencies. Does
> Emacs have any connections there we could reach out to? If not I
> can send bug report.
> 
> > And what, if anything, should we do with the patch you posted a few
> > messages ago? is it also needed?
> 
> It is not needed but users of the GTK builds might find it an
> improvement as it makes Dired match the style of their system’s
> icon theme. Maybe we could try it on master and be ready to revert
> if it proves unwelcome. The attached image shows the current
> situation on top and the patched version below.
> 
> However, a non-exhaustive search of the archives didn’t turn up
> any complaints about the current state so maybe everyone is happy
> enough as is…or has the tool-bar disabled, doesn’t care and it’s
> not even worth the effort to test it on master.
> 
> FTR: I do use the tool-bar all the time on GUI frames and find the
> mismash of icon styles very mildly annoying.
> 
> > If it is not needed after installing
> > gdk-pixbuf2-modules-extra, then how did that patch solve the problem
> > without the icons?
> 
> The patch “fixed” it by mapping etc/images/diropen to a system
> icon (part of the stock icons and already available by default)
> which meant that it wouldn’t try to fallback on
> etc/images/diropen.xpm. Therefore it wouldn’t run into the issue
> of the missing XPM loader that is part of the
> gdk-pixbuf2-modules-extra package.
> 
> The patch does nothing for all the other missing icons I mentioned
> (message-mode, Info &c.). Installing the package of extra loaders
> fixes all those as they are once again able to load from the
> etc/images/*.xpm files.
> 
> > IOW, this issue is still some black magic to me, and I'd like the
> > mystery be lifted.
> >
> > Thanks.
> 
> I hope that it’s at least a little less mysterious now.

OK, thanks.  I've now added a PROBLEMS entry about this on the
emacs-20 release branch, and I'm therefore closing this bug.